| IGLib 1.6.0 The IGLib base library for development of numerical, technical and business applications.

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Properties Events
Public Member Functions | Static Public Member Functions | Public Attributes | Properties | Private Attributes | List of all members
IG.Num.NeuralTrainingTable Class Reference

Contains Parameters that define neural network architecture and trainig limits, together with achieved results after training such as various error norms. More...

Inheritance diagram for IG.Num.NeuralTrainingTable:
[legend]
Collaboration diagram for IG.Num.NeuralTrainingTable:
[legend]

## Public Member Functions
void | UpdateTrainingTableDimensionns ()
| Updates the list of dimensions of the table of training results (contained in the list TrainingParameters). More...
int | GetIndex (int[] indices)
| Returns the index of the element in the onedimensional list that corresponds to the specified indices of the multidimensional table of elements. More...
void | GetIndices (int oneDimensionalIndex, ref int[] tableIndices)
| Calculates and stores the multidimensional indices of an element of the multidimensional table of training parameters & results. More...

## Static Public Member Functions
static void | SaveJson (NeuralTrainingTable trainingResults, string filePath)
| Saves (serializes) the specified training parameters object to the specified JSON file. File is owerwritten if it exists. More...
static void | SaveJson (NeuralTrainingTable trainingResults, string filePath, bool append)
| Saves (serializes) the specified training parameters object to the specified JSON file. More...
static void | LoadJson (string filePath, ref NeuralTrainingTable trainingResultsRestored)
| Restores (deserializes) a training parameters object from the specified file in JSON format. More...

## Public Attributes
NeuralTrainingLimits | _trainingLimits = null
List< NeuralTrainingParameters > | _trainingParameters = null

## Properties
object | Lock`[get]`
| This object's central lock object to be used by other object. Do not use this object for locking in class' methods, for this you should use InternalLock. More...
NeuralTrainingLimits | TrainingLimits`[get, set]`
| Contains Parameters that define neural network architecture limits and trainig parameter limits. More...
List< NeuralTrainingParameters > | TrainingParameters`[get, set]`
| Contains Parameters that define neural network architecture and trainig procedure, together with achieved results after training such as various error norms. More...
List< int > | TrainingTableDimensions`[get, private set]`
| List of dimensions of the table of training results. More...
NeuralTrainingParameters this[params int[] | indices`[get]`
| Gets the element of the training table specified by the indices. More...
Properties inherited from IG.Lib.ILockable
object | Lock`[get]`

## Private Attributes
object | _mainLock = new object()
List< int > | _trainingTableDimensions

## Detailed Description

Contains Parameters that define neural network architecture and trainig limits, together with achieved results after training such as various error norms.

Not thread safe!

This class is used for storing parameters and limits of neural networks and restoring them at a later time, in order to repeat training under similar condition or simply to analyse performance of neural networks.

$A Igor Jul10 Aug12; Tako78 Aug12;

## Member Function Documentation

void IG.Num.NeuralTrainingTable.UpdateTrainingTableDimensionns | ( |  | ) |
| inline

Updates the list of dimensions of the table of training results (contained in the list TrainingParameters).

References IG.Num.NeuralTrainingLimits.IterateThroughMultidimensionalTable().

int IG.Num.NeuralTrainingTable.GetIndex | ( | int[] | indices | ) |
| inline

Returns the index of the element in the onedimensional list that corresponds to the specified indices of the multidimensional table of elements.

Parameters

  indices | Indices of the element in the multidimensional table of training results.

Returns
  One dimensional index that corresponds to the specified multidimensional indices of the element of the multidimensional table of training results.

References IG.Lib.Util.GetIndex().

void IG.Num.NeuralTrainingTable.GetIndices | ( | int | oneDimensionalIndex,
|  | ref int[] | tableIndices
| ) |  |
| inline

Calculates and stores the multidimensional indices of an element of the multidimensional table of training parameters & results.

Parameters

  oneDimensionalIndex | One dimensional index that defines the position of the element in the list of elements.
  tableIndices | Variable where multidimensional indices of the element are stored.

References IG.Lib.Util.GetIndices().

static void IG.Num.NeuralTrainingTable.SaveJson | ( | NeuralTrainingTable | trainingResults,
|  | string | filePath
| ) |  |
| inline static

Saves (serializes) the specified training parameters object to the specified JSON file. File is owerwritten if it exists.

Parameters

  trainingParameters | Object that is saved to a file.
  inputFilePath | Path to the file into which object is is saved.

static void IG.Num.NeuralTrainingTable.SaveJson | ( | NeuralTrainingTable | trainingResults,
|  | string | filePath,
|  | bool | append
| ) |  |
| inline static

Saves (serializes) the specified training parameters object to the specified JSON file.

Parameters

  trainingParameters | Object that is saved to a file.
  inputFilePath | Path to the file into which object is is saved.
  append | Specifies whether serialized data is appended at the end of the file in the case that the file already exists.

static void IG.Num.NeuralTrainingTable.LoadJson | ( | string | filePath,
|  | ref NeuralTrainingTable | trainingResultsRestored
| ) |  |
| inline static

Restores (deserializes) a training parameters object from the specified file in JSON format.

Parameters

  inputFilePath | File from which object data is restored.
  trainingParametersRestored | Object that is restored by deserialization.

## Member Data Documentation

object IG.Num.NeuralTrainingTable._mainLock = new object()
| private

NeuralTrainingLimits IG.Num.NeuralTrainingTable._trainingLimits = null

List<NeuralTrainingParameters> IG.Num.NeuralTrainingTable._trainingParameters = null

List<int> IG.Num.NeuralTrainingTable._trainingTableDimensions
| private

## Property Documentation

object IG.Num.NeuralTrainingTable.Lock
| get

This object's central lock object to be used by other object. Do not use this object for locking in class' methods, for this you should use InternalLock.

NeuralTrainingLimits IG.Num.NeuralTrainingTable.TrainingLimits
| get set

Contains Parameters that define neural network architecture limits and trainig parameter limits.

Referenced by IG.Num.NeuralTrainingTableDto.CopyFromPlain().

List<NeuralTrainingParameters> IG.Num.NeuralTrainingTable.TrainingParameters
| get set

Contains Parameters that define neural network architecture and trainig procedure, together with achieved results after training such as various error norms.

Referenced by IG.Num.NeuralTrainingTableDto.CopyFromPlain(), and IG.Num.TestTrainingParametersComparers.Test().

List<int> IG.Num.NeuralTrainingTable.TrainingTableDimensions
| get private set

List of dimensions of the table of training results.

NeuralTrainingParameters this[params int[] IG.Num.NeuralTrainingTable.indices
| get

Gets the element of the training table specified by the indices.

Parameters

  indices | Indices of the element in the table of training parameters.

The documentation for this class was generated from the following file:

- igbase/numeric/approximation/neural/NeuralTrainingParameters.cs